//
// Copyright (c) 2016, MindFusion LLC - Bulgaria.
//

using System;
using System.Windows.Forms;


namespace MindFusion.Scheduling.WinForms.Samples.CS.ListView
{
	public partial class MainForm : Form
	{
		public MainForm()
		{
			InitializeComponent();

			_appPath = System.IO.Path.GetDirectoryName(Application.ExecutablePath);

			_lbInfo.DocumentText = Properties.Resources.Info;
			_lbInfo.DocumentCompleted += new WebBrowserDocumentCompletedEventHandler(OnDocumentCompleted);

			// Initialize appointments
			Appointment app;

			app = new Appointment();
			app.StartTime = new DateTime(2008, 10, 27);
			app.EndTime = new DateTime(2008, 11, 3);
			app.HeaderText = "Naruto #35\nM 10/27 - F 11/10";
			app.Priority = 0;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 10, 27);
			app.EndTime = new DateTime(2008, 11, 3);
			app.HeaderText = "Dragon Ball #10\nM 10/27 - F 11/10";
			app.Priority = -1;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 10, 27);
			app.EndTime = new DateTime(2008, 11, 3);
			app.HeaderText = "Hikaru No Go #38\nM 10/27 - F 11/10";
			app.Priority = -2;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 10, 27);
			app.EndTime = new DateTime(2008, 11, 3);
			app.HeaderText = "MAR #5\nM 10/27 - F 11/10";
			app.Priority = -3;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 10, 27);
			app.EndTime = new DateTime(2008, 11, 3);
			app.HeaderText = "Pokemnon: Johto...\nM 10/27 - F 11/10";
			app.Priority = -4;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 10, 27);
			app.EndTime = new DateTime(2008, 11, 3);
			app.HeaderText = "One Piece\nM 10/27 - F 11/10";
			app.Priority = -5;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "Naruto #36\nM 11/6 - F 11/17";
			app.Priority = 0;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "Dragon Ball #11\nM 11/6 - F 11/17";
			app.Priority = -1;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "Hikaru No Go\nM 11/6 - F 11/17";
			app.Priority = -2;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "MAR #39\nM 11/6 - F 11/17";
			app.Priority = -3;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "Pokemon: Johto...\nM 11/6 - F 11/17";
			app.Priority = -4;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "One Piece\nM 11/6 - F 11/17";
			app.Priority = -5;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "Dragon Ball\nM 11/6 - F 11/17";
			app.Priority = -6;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "Hikaru No Go\nM 11/6 - F 11/17";
			app.Priority = -7;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "MAR\nM 11/6 - F 11/17";
			app.Priority = -8;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "Pokemon: Johto...\nM 11/6 - F 11/17";
			app.Priority = -9;
			calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2008, 11, 3);
			app.EndTime = new DateTime(2008, 11, 10);
			app.HeaderText = "One Piece\nM 11/6 - F 11/17";
			app.Priority = -10;
			calendar.Schedule.Items.Add(app);
		}

		private void OnDocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
		{
			if (_lbInfo.Document != null)
			{
				_lbInfo.Document.Click += Document_Click;
				_lbInfo.Document.Body.Style = "font-family: Verdana, Arial, Helvetica, sans-serif; " +
					"font-size: 7.5pt; margin: 2pt; padding: 0pt; background-color: #ffffee; cursor: default;";
			}
		}

		/// <summary>
		/// Handles the Web browser document's Click event.
		/// </summary>
		private void Document_Click(object sender, HtmlElementEventArgs e)
		{
			e.ReturnValue = true;

			HtmlElement pointed = _lbInfo.Document.GetElementFromPoint(e.ClientMousePosition);
			if (pointed == null)
				return;

			if (pointed.TagName.ToLower() == "a")
			{
				string href = pointed.GetAttribute("href").ToLower();
				if (href.StartsWith("help:"))
				{
					string topic = href.Substring(5);
					string helpFile = ResolveHelpPath(_appPath);

					if (System.IO.File.Exists(helpFile))
					{
						Help.ShowHelp(this, helpFile, HelpNavigator.Topic, topic);

						// Prevent link follow
						e.ReturnValue = false;
					}
				}
			}
		}

		private static string ResolveHelpPath(string baseDir)
		{
			string[] helpFiles = new string[]
			{
				"MindFusion.Scheduling.chm",
				"MindFusion WinForms.chm"
			};

			System.IO.DirectoryInfo dirInfo = new System.IO.DirectoryInfo(baseDir);
			int i = 0;
			while (dirInfo != null)
			{
				string helpFile = System.IO.Path.Combine(dirInfo.FullName, helpFiles[i]);
				if (System.IO.File.Exists(helpFile))
					return helpFile;

				i++;
				if (i == helpFiles.Length)
				{
					i = 0;
					dirInfo = dirInfo.Parent;
				}
			}

			return string.Empty;
		}

		private void OnAbout(object sender, System.EventArgs e)
		{
			System.Reflection.Assembly assembly = System.Reflection.Assembly.GetAssembly(
				typeof(MindFusion.Scheduling.WinForms.Calendar));

			if (assembly == null)
				return;

			Type aboutFormType = assembly.GetType(
				"MindFusion.Scheduling.WinForms.AboutForm");

			if (aboutFormType == null)
				return;

			((Form)Activator.CreateInstance(aboutFormType)).ShowDialog(this);
		}

		private void OnExit(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void _menuItemToggleFreeDrag_Click(object sender, EventArgs e)
		{
			if (calendar.ListViewSettings.FreeDrag == State.Enabled)
				calendar.ListViewSettings.FreeDrag = State.Disabled;
			else
				calendar.ListViewSettings.FreeDrag = State.Enabled;
		}

		private void _menuItemToggleSubHeaders_Click(object sender, EventArgs e)
		{
			ListViewHeaderStyles style = calendar.ListViewSettings.HeaderStyle;
			if ((style & ListViewHeaderStyles.Subheader) == 0)
				style |= ListViewHeaderStyles.Subheader;
			else
				style &= ~ListViewHeaderStyles.Subheader;
			calendar.ListViewSettings.HeaderStyle = style;
		}

		private void _menuItemSnapToCell_Click(object sender, EventArgs e)
		{
			// Effectively disable custom snapping
			calendar.ListViewSettings.EnableSnapping = State.Disabled;
		}

		private void _menuItemSnapToSecond_Click(object sender, EventArgs e)
		{
			// Enable custom snapping
			calendar.ListViewSettings.EnableSnapping = State.Enabled;
			calendar.ListViewSettings.SnapUnit = TimeUnit.Second;
		}

		private void _menuItemSnapToHour_Click(object sender, EventArgs e)
		{
			// Enable custom snapping
			calendar.ListViewSettings.EnableSnapping = State.Enabled;
			calendar.ListViewSettings.SnapUnit = TimeUnit.Hour;
		}

		private void _menuItemSnapToDay_Click(object sender, EventArgs e)
		{
			// Enable custom snapping
			calendar.ListViewSettings.EnableSnapping = State.Enabled;
			calendar.ListViewSettings.SnapUnit = TimeUnit.Day;
		}

		private void _menuItemTools_DropDownOpening(object sender, EventArgs e)
		{
			_menuItemToggleFreeDrag.Checked =
				(calendar.ListViewSettings.FreeDrag == State.Enabled);
			_menuItemToggleSubHeaders.Checked =
				(calendar.ListViewSettings.HeaderStyle & ListViewHeaderStyles.Subheader) != 0;

			_menuItemSnapToCell.Checked =
				calendar.ListViewSettings.EnableSnapping == State.Disabled;
			_menuItemSnapToSecond.Checked =
				(calendar.ListViewSettings.EnableSnapping == State.Enabled &&
				calendar.ListViewSettings.SnapUnit == TimeUnit.Second);
			_menuItemSnapToHour.Checked =
				(calendar.ListViewSettings.EnableSnapping == State.Enabled &&
				calendar.ListViewSettings.SnapUnit == TimeUnit.Hour);
			_menuItemSnapToDay.Checked =
				(calendar.ListViewSettings.EnableSnapping == State.Enabled &&
				calendar.ListViewSettings.SnapUnit == TimeUnit.Day);
		}


		private string _appPath;
	}
}